// Code generated by go-swagger; DO NOT EDIT.

package virtual_machines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMCreateHandlerFunc turns a function with the right signature into a vm create handler
type VMCreateHandlerFunc func(VMCreateParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMCreateHandlerFunc) Handle(params VMCreateParams) middleware.Responder {
	return fn(params)
}

// VMCreateHandler interface for that can handle valid vm create params
type VMCreateHandler interface {
	Handle(VMCreateParams) middleware.Responder
}

// NewVMCreate creates a new http.Handler for the vm create operation
func NewVMCreate(ctx *middleware.Context, handler VMCreateHandler) *VMCreate {
	return &VMCreate{Context: ctx, Handler: handler}
}

/*VMCreate swagger:route POST /api/vms Virtual machines vmCreate

Create virtual machine

*/
type VMCreate struct {
	Context *middleware.Context
	Handler VMCreateHandler
}

func (o *VMCreate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMCreateParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
